	device zxspectrum128

start		equ #6000
screen_address	equ #c000

dot_tab		equ #8000		; [#0400]
stars_tab	equ dot_tab+#400	; [#0100]

im_tab		equ #be00		;[#0200]

color		equ #47
stars_count	equ 10

	org start

	call init

	ld a,128
	call stars_init
	ei

loop
	ld a,#1d: xor 10: ld (loop+1),a: call set_bnk
	call cls_pix
	call stars_render
	halt

	call stars_move

	jp loop


	jr $

; starfield - initial setup, generation coords
; in: a - stars count
; out: stars coordinates in stars_tab
stars_init
	call im2_init
	ld hl,stars_tab
1	push af,hl
	ld a,#ff: call rnd_x: ld d,a	; random X coord
	ld a,#bf: call rnd_x: ld e,a	; random Y coord
	pop hl
	ld (hl),e: inc hl: ld (hl),d: inc hl
	pop af: dec a: jr nz,1b
	ld (hl),#ff: inc hl: ld (hl),#ff
	ret

; starfiend - render a frame
stars_render
	ld (stars_render_sp+1),sp, sp,stars_tab, ix, stars_render_loop
stars_render_loop
	pop hl: inc hl: ld a,h: or l: jp z,stars_render_sp
	dec hl: jp dot_put_ix
stars_render_sp
	ld sp,0
	ret

stars_move
	ld hl,stars_tab, a,#ff
1b	cp (hl): ret z
	inc hl, (hl), hl
	jp 1b

; ----- init
init
	sub a: out (#fe),a

	ld hl,#4000, bc,#1800, de,hl: inc de: ld (hl),l: ldir
	ld bc,#2ff, (hl),color: ldir
	ld a,#17: call set_bnk
	ld hl,#4000, de,#c000, bc,#1b00: ldir


	call dot_init
	ret

; ----- modules
	include "lib/routines.asm"

	; dot_init
	; dot_put
	include "modules/dot.asm"

	savesna "demo.sna",start
	savesna "../_tools/unreal/qsave1.sna", start
	labelslist "../_tools/unreal/user.l"
